diff --git a/gcc/Makefile.in b/gcc/Makefile.in
index c53c78a2f03..78f17e4f745 100644
--- a/gcc/Makefile.in
+++ b/gcc/Makefile.in
@@ -1329,7 +1329,7 @@ OBJS = \
 	haifa-sched.o \
 	hash-map-tests.o \
 	hash-set-tests.o \
-	hsa.o \
+	hsa-common.o \
 	hsa-gen.o \
 	hsa-regalloc.o \
 	hsa-brig.o \
@@ -2516,7 +2516,7 @@ GTFILES = $(CPP_ID_DATA_H) $(srcdir)/input.h $(srcdir)/coretypes.h \
   $(srcdir)/sancov.c \
   $(srcdir)/ipa-devirt.c \
   $(srcdir)/internal-fn.h \
-  $(srcdir)/hsa.c \
+  $(srcdir)/hsa-common.c \
   @all_gtfiles@
 
 # Compute the list of GT header files from the corresponding C sources,
diff --git a/gcc/hsa-brig.c b/gcc/hsa-brig.c
index 5fe302f25f5..1a2d45fcc52 100644
--- a/gcc/hsa-brig.c
+++ b/gcc/hsa-brig.c
@@ -44,7 +44,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "dumpfile.h"
 #include "print-tree.h"
 #include "symbol-summary.h"
-#include "hsa.h"
+#include "hsa-common.h"
 #include "gomp-constants.h"
 
 /* Convert VAL to little endian form, if necessary.  */
diff --git a/gcc/hsa.c b/gcc/hsa-common.c
similarity index 99%
rename from gcc/hsa.c
rename to gcc/hsa-common.c
index 2035ce446a1..95636ebc9a8 100644
--- a/gcc/hsa.c
+++ b/gcc/hsa-common.c
@@ -36,7 +36,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "print-tree.h"
 #include "stringpool.h"
 #include "symbol-summary.h"
-#include "hsa.h"
+#include "hsa-common.h"
 #include "internal-fn.h"
 #include "ctype.h"
 #include "builtins.h"
@@ -991,4 +991,4 @@ hsa_internal_fn::get_argument_type (int n)
     }
 }
 
-#include "gt-hsa.h"
+#include "gt-hsa-common.h"
diff --git a/gcc/hsa.h b/gcc/hsa-common.h
similarity index 99%
rename from gcc/hsa.h
rename to gcc/hsa-common.h
index a74f2d9553b..a24bf6e5ad1 100644
--- a/gcc/hsa.h
+++ b/gcc/hsa-common.h
@@ -1309,7 +1309,7 @@ hsa_internal_fn_hasher::equal (const value_type a, const compare_type b)
   return a->m_fn == b->m_fn && a->m_type_bit_size == b->m_type_bit_size;
 }
 
-/* in hsa.c */
+/* in hsa-common.c */
 extern struct hsa_function_representation *hsa_cfun;
 extern hash_map <tree, vec <const char *> *> *hsa_decl_kernel_dependencies;
 extern hsa_summary_t *hsa_summaries;
diff --git a/gcc/hsa-dump.c b/gcc/hsa-dump.c
index 1cd128ea3b4..e2ef58693c9 100644
--- a/gcc/hsa-dump.c
+++ b/gcc/hsa-dump.c
@@ -33,7 +33,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "cgraph.h"
 #include "print-tree.h"
 #include "symbol-summary.h"
-#include "hsa.h"
+#include "hsa-common.h"
 
 /* Return textual name of TYPE.  */
 
diff --git a/gcc/hsa-gen.c b/gcc/hsa-gen.c
index 632561d5e45..7721fcc9334 100644
--- a/gcc/hsa-gen.c
+++ b/gcc/hsa-gen.c
@@ -49,7 +49,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "cgraph.h"
 #include "print-tree.h"
 #include "symbol-summary.h"
-#include "hsa.h"
+#include "hsa-common.h"
 #include "cfghooks.h"
 #include "tree-cfg.h"
 #include "cfgloop.h"
diff --git a/gcc/hsa-regalloc.c b/gcc/hsa-regalloc.c
index 5f2ac13c823..4d9441c91d4 100644
--- a/gcc/hsa-regalloc.c
+++ b/gcc/hsa-regalloc.c
@@ -35,7 +35,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "print-tree.h"
 #include "cfghooks.h"
 #include "symbol-summary.h"
-#include "hsa.h"
+#include "hsa-common.h"
 
 
 /* Process a PHI node PHI of basic block BB as a part of naive out-f-ssa.  */
diff --git a/gcc/ipa-hsa.c b/gcc/ipa-hsa.c
index 6a3f660672e..af70b0a9230 100644
--- a/gcc/ipa-hsa.c
+++ b/gcc/ipa-hsa.c
@@ -41,7 +41,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "cgraph.h"
 #include "print-tree.h"
 #include "symbol-summary.h"
-#include "hsa.h"
+#include "hsa-common.h"
 
 namespace {
 
diff --git a/gcc/omp-expand.c b/gcc/omp-expand.c
index f0e98873e28..57d9fdea85a 100644
--- a/gcc/omp-expand.c
+++ b/gcc/omp-expand.c
@@ -56,7 +56,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "cilk.h"
 #include "gomp-constants.h"
 #include "gimple-pretty-print.h"
-#include "hsa.h"
+#include "hsa-common.h"
 
 
 /* OMP region information.  Every parallel and workshare
diff --git a/gcc/omp-low.c b/gcc/omp-low.c
index e8d78a91abc..6d30ca617b3 100644
--- a/gcc/omp-low.c
+++ b/gcc/omp-low.c
@@ -57,7 +57,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "context.h"
 #include "gomp-constants.h"
 #include "gimple-pretty-print.h"
-#include "hsa.h"
+#include "hsa-common.h"
 
 /* Lowering of OMP parallel and workshare constructs proceeds in two
    phases.  The first phase scans the function looking for OMP statements
diff --git a/gcc/toplev.c b/gcc/toplev.c
index c0f1a2df517..2335ad716ae 100644
--- a/gcc/toplev.c
+++ b/gcc/toplev.c
@@ -77,7 +77,7 @@ along with GCC; see the file COPYING3.  If not see
 #include "gcse.h"
 #include "tree-chkp.h"
 #include "omp-offload.h"
-#include "hsa.h"
+#include "hsa-common.h"
 #include "edit-context.h"
 
 #if defined(DBX_DEBUGGING_INFO) || defined(XCOFF_DEBUGGING_INFO)